/***********************************************************************/
/*                                                                     */
/* Simple sample program to put a single message of format BALANCE.    */
/* Copyright IBM Corp 1997.                                            */
/*                                                                     */
/***********************************************************************/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <cmqc.h>
#include "Balance.h"

#define MAX_TEXT 72

enum rc_e { good_rc, bad_rc };

int main( int argc, char *argv[] )
{

 static MQCHAR48   qmname = { '\0'};            /* Queue manager name   */
 MQHCONN           hconn;                       /* Connection handle    */
 MQLONG            cc;                          /* Completion code      */
 MQLONG            rc;                          /* Reason               */
 char              msg[ MAX_TEXT ];             /* Error message        */
 int               i;                           /* Index variable       */
 static MQOD       mqod  = { MQOD_DEFAULT };    /* Object descriptor    */
 static MQMD       mqmd  = { MQMD_DEFAULT };    /* Message descriptor   */
 static MQPMO      mqpmo = { MQPMO_DEFAULT };   /* Put options          */
 struct BALANCE    Balance;                     /* MQ msg to send       */

 if ( argc !=2 )
 {
  sprintf( msg, "Usage: %s queue_name\n", argv[0] );
  fputs(   msg, stderr );
  exit(    bad_rc );
 }
 strcpy( mqod.ObjectName, argv[ 1 ] );

 MQCONN( qmname, &hconn, &cc, &rc );  /* Connect to default QMgr */
 if ( cc != MQCC_OK )
 {
  sprintf( msg, "MQCONN failed - reason code %li\n", rc );
  fputs(   msg, stderr );
  exit(    bad_rc );
 }
 
 strncpy( mqmd.Format, "BALANCE  ", sizeof( mqmd.Format ) );
 CStrToChars( Balance.AccountHolder, "Megabucks Stefan", 
              sizeof( Balance.AccountHolder ) );
 CStrToChars( Balance.AccountNumber, "123456", 
              sizeof( Balance.AccountNumber ) );
 Balance.CurrentBalance = 1999;
 
 MQPUT1( hconn,
        &mqod,
        &mqmd,
        &mqpmo,
         sizeof( struct BALANCE ),
        &Balance,
        &cc,
        &rc );
  if ( cc != MQCC_OK )
  {
   sprintf( msg, "MQPUT1 failed - reason code %li\n", rc );
   fputs(   msg, stderr );
   exit(    bad_rc );
  }

  MQDISC( &hconn, &cc, &rc );
  exit( good_rc );

}  /* main */
